'use strict';
angular.module('Tianguisapp.controllers', [])

.controller('AppCtrl', function ($scope, User, $location, Chat, $ionicLoading,  socket, Geo) {

  var tempUser;

  socket.on('message',function (data) {
    console.log("data",data);
    $location.path('chat/'+data._id);

    /*for (var i = 0; i < $scope.chatsUsers.length; i++) {
      if ($scope.chatsUsers[i]._id!=data._id) {
        $scope.chatsUsers.push(data);
      }
    }*/
  });

  $scope.showLoad = function() {
    $ionicLoading.show({
      template: 'Un momento ya casi...'
    });
  };
  $scope.hideLoad = function(){
    $ionicLoading.hide();
  };

  // Default Position
  $scope.point = { latitude: 20.653467, longitude: -105.225255 };
  $scope.chatsUsers = [];


  var user , urlCategory = 'http://tianguisapp.herokuapp.com/categories/listByUser';

  $scope.ajaxCategories = function (isSaved) {
    if (!isSaved) {
      urlCategory = 'http://tianguisapp.herokuapp.com/categories/default';
    }else{
      urlCategory = 'http://tianguisapp.herokuapp.com/categories/listByUser';
    }

    // usar este método para obtener las categorías por default
    $.ajax({
      url: urlCategory,
      type: 'GET',
      contentType: false,
      cache: true,
      processData:false,
      async: false,
      xhrFields: {
        withCredentials: true
      },
      crossDomain: true,
      success: function (data) {
        $scope.categories = data.categories;
      },
      error: function (err) {
        console.log(err);
      },
      beforeSend: function(){
        $scope.showLoad();
      },
      complete: function(){
        $scope.hideLoad();
      }
    });
  };

  /////////// Este código pertenece al sistema de chat /////////////////////////
  $scope.loadChats = function (isLogged) {
    Chat.getChats(function (chats, chatsUsers) {
      if (!chatsUsers) chatsUsers = [];
      $scope.chats = chats;
      $scope.chatsUsers = chatsUsers;
    });
  }
  ////////////////////////////////////////////////////////////////////////7777//


    User.isLogged(function (isLogged) {
      var login = localStorage.getObject('login');
      user = User.getInfo();
      if (isLogged && user) {
        $scope.ajaxCategories(true);

        console.log(user._id);
        socket.emit('join', {_id:user._id});
      }else if(user){
        User.login(login,$scope.point,function (err) {
          if (err) {
            urlCategory = 'http://tianguisapp.herokuapp.com/categories/default';
            $scope.ajaxCategories(false);
          }else{
            $scope.ajaxCategories(true);
            socket.emit('join', {_id:user._id});
          }
        });
      }else{
        urlCategory = 'http://tianguisapp.herokuapp.com/categories/default';
        $scope.ajaxCategories(false);
      }
      $scope.loadChats();
    });

  $scope.openConfig = function () {
    if (!User.isSaved()) {
      $location.path('/login-intro');
    }else{
      $location.path('/config');
    }
  };

  $scope.$on('chat-list',function (name, chatList) {
    if (!chatList) {
      $scope.chatsUsers = [];
    }else{
      $scope.chatsUsers = chatList;
    }
  });

  $scope.$on('categories', function(response) {
    console.log("Is isSaved",User.isSaved());
    if (User.isSaved()) {
      $scope.ajaxCategories(true);
    }else{
      $scope.ajaxCategories(false);
    }
  })

})

.controller('ProductsCtrl', function ($scope, $location, $ionicLoading , socket, Geo, User) {


  var user = User.getInfo();
  if (user) {
    socket.emit('join', {_id:user._id});
  }

  $scope.products = [];
  $scope.productsPage = 1;


  $scope.point = { latitude: 20.653467, longitude: -105.225255 };

  $scope.loadProducts = function () {
    $scope.point = Geo.point(function (point) {
      $scope.point = point;
      console.log('http://tianguisapp.herokuapp.com/products/nearByRequest/'+($scope.productsPage)+'/'+$scope.point.latitude+','+$scope.point.longitude);

      console.log('http://tianguisapp.herokuapp.com/products/nearByRequest/'+($scope.productsPage)+'/'+$scope.point.latitude+','+$scope.point.longitude);
      $.ajax({
        url: 'http://tianguisapp.herokuapp.com/products/nearByRequest/'+($scope.productsPage++)+'/'+$scope.point.latitude+','+$scope.point.longitude,
        type: 'GET',
        contentType: false,
        cache: true,
        processData:false,
        async: false,
        xhrFields: {
          withCredentials: true
        },
        crossDomain: true,
        success: function (data) {
          //$scope.products = data.products;
          $scope.productsLength = data.products.length;

          for (var i = 0; i < $scope.productsLength; i++) {
            console.log(data.products[i].images[0].path_s);
            $scope.products.push(data.products[i]);
          }
          $scope.$broadcast('scroll.infiniteScrollComplete');
          $scope.$apply();
        },
        error: function (jqXHR, textStatus, errorThrown) {
          console.log(jqXHR, textStatus, errorThrown);
        }
      });
    });
  };
  $scope.loadProducts();

  var w = window,
    d = document,
    e = d.documentElement,
    g = d.getElementsByTagName('body')[0],
    x = w.innerWidth || w.screen.availWidth || e.clientWidth || g.clientWidth,

    elementWidth = (x / 2)-1;

  $scope.properties = {
    width: elementWidth
  };

  $scope.showProducts = function () {
    $location.path('/products');
  };

  $scope.openNewProduct = function () {
    $location.path('/new_product');
  };

  // Busca todos los productos por nombre
  $('#search-form').submit(function () {

    var text = this.s.value;
    this.s.value = '';
    if ( text === '' ) {
      $('.top-search-input').hide();
      return false;
    }

    $.ajax({
      url: 'http://tianguisapp.herokuapp.com/products/name/'+text,
      type: 'GET',
      contentType: false,
      cache: true,
      processData:false,
      async: false,
      xhrFields: {
        withCredentials: true
      },
      crossDomain: true,
      success: function (data) {
        console.log(data);
        // INSTEND data SHOULD USE data.products
        $scope.products = data.products;
        $scope.$apply();
      },
      error: function (jqXHR, textStatus, errorThrown) {
        console.log(jqXHR, textStatus, errorThrown);
      },
      beforeSend: function(){
        $scope.showLoad();
      },
      complete: function(){
        $scope.hideLoad();
      }
    });
  });

  $scope.add = function add(product) {
    $scope.products.push(product);
  };

  $scope.closeForm = function () {
    $('.top-search-input').hide();
  };

  $('#search-form').submit(function (e) {
    $('.top-search-input').hide();
    e.preventDefault();
  });

  $scope.displaySearch = function () {
    $('.top-search-input').show();
  };

})

.controller('ProductsRequestCtrl', function ($scope, $stateParams) {
  // La única diferencia entre productsCtrl y productsREquestCtrl es que el segundo
  // y retorna productos de acuerdo a varios parámetros no tinen tantas funciones como agregar y buscar

  $scope.products = [];

  if($stateParams.userid){
    // TODO : unificar todas las llamadas ajax en una función
    $.ajax({
      url: 'http://tianguisapp.herokuapp.com/products/owner/'+$stateParams.userid,
      type: 'GET',
      contentType: false,
      cache: true,
      processData:false,
      async: false,
      xhrFields: {
        withCredentials: true
      },
      crossDomain: true,
      success: function (data) {
        console.log(data);
        $scope.products = data.products;
        //$scope.$apply();
      },
      error: function (jqXHR, textStatus, errorThrown) {
        console.log(jqXHR, textStatus, errorThrown);
      }
    });

    $.ajax({
      url: 'http://tianguisapp.herokuapp.com/user/'+$stateParams.userid,
      type: 'GET',
      contentType: false,
      cache: true,
      processData:false,
      async: false,
      xhrFields: {
        withCredentials: true
      },
      crossDomain: true,
      success: function (data) {
        if (!data.error) {
          $scope.owner = data.user;
          $scope.title = $scope.owner.name +" "+ $scope.owner.lastname +" "+ $scope.owner.second_lastname;

        }else{
          if (data.error.errors.system) {
            console.log(data.error.errors.system.name);
          }
        }
      },
      error: function (jqXHR, textStatus, errorThrown) {
        console.log(jqXHR, textStatus, errorThrown);
      }
    });

  }
  if ($stateParams.categoryid) {
    $.ajax({
      url: 'http://tianguisapp.herokuapp.com/products/categoryID/'+$stateParams.categoryid,
      type: 'GET',
      contentType: false,
      cache: true,
      processData:false,
      async: false,
      xhrFields: {
        withCredentials: true
      },
      crossDomain: true,
      success: function (data) {
        $scope.products = data.products;
      },
      error: function (jqXHR, textStatus, errorThrown) {
        console.log(jqXHR, textStatus, errorThrown);
      }
    });

    $.ajax({
      url: 'http://tianguisapp.herokuapp.com/category/'+$stateParams.categoryid,
      type: 'GET',
      contentType: false,
      cache: true,
      processData:false,
      async: false,
      xhrFields: {
        withCredentials: true
      },
      crossDomain: true,
      success: function (data) {
        $scope.category = data.category;
        $scope.title  = $scope.category.name;
      },
      error: function (jqXHR, textStatus, errorThrown) {
        console.log(jqXHR, textStatus, errorThrown);
      }
    });
  };

  var w = window,
    d = document,
    e = d.documentElement,
    g = d.getElementsByTagName('body')[0],
    x = w.innerWidth || w.screen.availWidth || e.clientWidth || g.clientWidth,

    elementWidth = (x / 2)-1;

  $scope.properties = {
    width: elementWidth
  };
})

.controller('ProductImageFullCtrl', function ($scope, $stateParams, User) {
  $scope.image = {};
  $.ajax({
    url: 'http://tianguisapp.herokuapp.com/product/'+$stateParams.productId,
    type: 'GET',
    contentType: false,
    cache: true,
    processData:false,
    async: false,
    xhrFields: {
      withCredentials: true
    },
    crossDomain: true,
    success: function (data) {
      console.log(data.product.images[$stateParams.imageNum]);
      if (!data.error) {
        $scope.image = data.product.images[$stateParams.imageNum].path_s;
        $scope.name = data.product.name;
      }
    },
    error: function (jqXHR, textStatus, errorThrown) {
      console.log(jqXHR, textStatus, errorThrown);
    }
  });
})

.controller('ConfigCtrl', function ($scope, User, $rootScope,  $ionicModal, $location) {


  if (!User.isSaved()) {
    console.log("to login");
    User.setPendingUrl($location.path());
    $location.path('/login-intro');
  }else{
    $scope.user = User.getInfo();

    $.ajax({
      url: 'http://tianguisapp.herokuapp.com/categories',
      type: 'GET',
      contentType: false,
      cache: true,
      processData:false,
      async: false,
      xhrFields: {
        withCredentials: true
      },
      crossDomain: true,
      success: function (data) {
        $scope.categories = data.categories;
        for (var i = 0; i < $scope.categories.length; i++) {
          if ($scope.user.likes.indexOf($scope.categories[i]._id) != -1) {
            $scope.categories[i].active = true;
          }
        }
      },
      error: function (err) {
        console.log("err",err);
      }
    });
  }

  $scope.likeChanged = function (id) {

    //console.log($('input:checkbox'));
    var length = $('input:checkbox').length;
    var likes  = [];
    var formData = new FormData();
    for (var i = 0; i < length; i++) {
      if ($('input:checkbox').eq(i).prop("checked")) {
        formData.append('likes',$('input:checkbox')[i].value);
        //likes.push();
      }
    }

    $.ajax({
      url: 'http://tianguisapp.herokuapp.com/user',
      type: 'PUT',
      data:  formData,
      contentType: false,
      cache: true,
      processData:false,
      xhrFields: {
        withCredentials: true
      },
      crossDomain: true,
      dataType: 'json',
      success: function (data) {

        if ( data.status === 'OK' ) {
          User.setInfo(data.user);
          $rootScope.$broadcast('categories', true);
        }
        if (data.error) {
          if (data.error.errors.system) {
            console.log('Ops!',data.error.errors.system.name );
          }
        }
      },
      error: function (data) {
        try {
          data = JSON.parse(data.responseText);
        }
        catch(err) {
          data = {};
          console.log('Ops!','Un error de conexión');
        }
        if (data.error) {
          if (data.error.errors.system) {
            console.log('Ops!',data.error.errors.system.name );
          }
        }
      }
    });

  };

  $scope.save = function () {
    $('#multiform').submit(function () {
      var formData = new FormData(this);
      $.ajax({
        url: 'http://tianguisapp.herokuapp.com/user',
        type: 'PUT',
        data:  formData,
        contentType: false,
        cache: true,
        processData:false,
        xhrFields: {
          withCredentials: true
        },
        crossDomain: true,
        dataType: 'json',
        mimeType:'multipart/form-data',
        success: function (data) {
          console.log(data);
          if ( data.status === 'OK' ) {
            User.setInfo(data.user);
            $scope.closeModal();
          }
          if (data.error) {
            if (data.error.errors.system) {
              popup('Ops!',data.error.errors.system.name );
            }
          }
        },
        error: function (data) {
          console.log(data.responseText);

          try {
            data = JSON.parse(data.responseText);
          }
          catch(err) {
            data = {};
            popup('Ops!','Un error de conexión');
          }
          console.log(data.error.errors.system);
          if (data.error.errors.system) {
            popup('Ops!',data.error.errors.system.name );
          }
        }
      });
    });
  }

  $ionicModal.fromTemplateUrl('modal-editpro.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modal = modal;
  });
  $scope.openModal = function() {
    $scope.modal.show();
  };
  $scope.closeModal = function() {
    $scope.modal.hide();
  };
  //Cleanup the modal when we're done with it!
  $scope.$on('$destroy', function() {
    $scope.modal.remove();
  });
  // Execute action on hide modal
  $scope.$on('modal.hidden', function() {
    // Execute action
  });
  // Execute action on remove modal
  $scope.$on('modal.removed', function() {
    // Execute action
  });

  $scope.closeApp = function () {
    // Petición al servidor para salir
    $.ajax({
      url: 'http://tianguisapp.herokuapp.com/logout',
      type: 'GET',
      contentType: false,
      cache: true,
      processData:false,
      async: false,
      xhrFields: {
        withCredentials: true
      },
      crossDomain: true,
      success: function (data) {

      },
      error: function (err) {
        console.log("err",err);
      }
    });
    // limpia el localStorage
    localStorage.clear();
    // Limpiar el listado de chat
    $rootScope.$broadcast('chat-list', false);
    // Se genrean las categorías por default
    $rootScope.$broadcast('categories', false);
    // redirecciona al inicio
    location = '#/';
    if (navigator.app) {
      navigator.app.exitApp();
    };

  }

})

.controller('NewProductCtrl', function ($scope, $ionicPopup, $location, $ionicLoading,  User) {

  // Si el usuario no está loeguado no hagas nada
  if (!User.isSaved()) {
    $location.path('/login-intro');
  };

  $scope.point = { latitude: 20.653467, longitude: -105.225255 };

  $scope.showLoad = function() {
    $ionicLoading.show({
      template: 'Subiendo imagen...'
    });
  };
  $scope.hideLoad = function(){
    $ionicLoading.hide();
  };

   // Establece de fondo la imagen antes subir hace uso de la directiva customOnChange
  $scope.uploadImage = function (){
    var file = this;
    if (this.files && this.files[0]) {
      console.log(this.files[0].name );
      var reader = new FileReader();
      reader.onload = function (e) {
        file.parentNode.style.backgroundImage = 'url('+e.target.result+')';
        file.parentNode.style.backgroundSize = '78px 80px';
      };
      reader.readAsDataURL(this.files[0]);
    }
  };

  $('#newproduct-form').submit(function () {
    // TODO: validar para que sólo acepte números en el precio

    if (this.name.value.trim()==='') {
      popup('Hey! falta el nombre','Debes poner un nombre al artículo');
      return false;
    }

    if (!(this.images[0].value.trim()!=='' || this.images[1].value.trim()!=='' || this.images[2].value.trim()!=='')) {
      popup(' ¿ Y la foto ?','Debes subir por lo menos una imagen');
      return false;
    }

    var formData = new FormData(this);
      formData.append('latitude',$scope.point.latitude);
      formData.append('longitude',$scope.point.longitude);
      $.ajax({
        url: 'http://tianguisapp.herokuapp.com/product',
        type: 'POST',
        data:  formData,
        contentType: false,
        cache: true,
        processData:false,
        xhrFields: {
          withCredentials: true
        },
        crossDomain: true,
        dataType: 'json',
        mimeType:'multipart/form-data',
        success: function (data) {
          console.log(data);
          if ( data.status === 'OK' ) {
            location = '#/my-products';
          }
          if (data.error) {
            $scope.hideLoad();
            if (data.error.errors.system) {
              popup('Ops!',data.error.errors.system.name );
            }
          }
        },
        error: function (data) {
          console.log(data.responseText);
          $scope.hideLoad();
          try {
            data = JSON.parse(data.responseText);
          }
          catch(err) {
            data = {};
            popup('Ops!','Un error de conexión');
          }
          console.log(data.error.errors.system);
          if (data.error.errors.system) {
            popup('Ops!',data.error.errors.system.name );
          }
        },
        beforeSend: function(){
          $scope.showLoad();
        },
        complete: function(){
          $scope.hideLoad();
        }
      });

  });

  User.getProductCategories(function (categories) {
    $scope.categories = categories;
  });


  function showErrors (err) {
    if( err.system ){
      popup('Wop!! algo anda mal','Ocurrió  un error en el servidor');
    }else{
      popup('ERROR','');
    }
  }
  function popup (title,text,callback) {
    var alertPopup = $ionicPopup.alert({
      title: title,
      template: text
    });
    alertPopup.then(function (res) {
      if (callback) {
        callback();
      }
    });
  }
})

.controller('SingupCtrl', function ($scope, $ionicPopup, $location, $rootScope, User, $ionicLoading, Chat, Geo) {

  $scope.point = { latitude: 20.653467, longitude: -105.225255 };

  $scope.showLoad = function() {
    $ionicLoading.show({
      template: 'Subiendo imagen...'
    });
  };
  $scope.hideLoad = function(){
    $ionicLoading.hide();
  };


  // Establece de fondo la imagen antes subir hace uso de la directiva customOnChange
  $scope.uploadImage = function (){
    var picImage = document.getElementById('pic-image');
    if (this.files && this.files[0]) {
      var reader = new FileReader();
      reader.onload = function (e) {
        picImage.style.backgroundImage = 'url('+e.target.result+')';
        picImage.style.backgroundSize = '78px 80px';
      };
      reader.readAsDataURL(this.files[0]);
    }
  };

  $('#multiform').submit(function (e){
    // TODO : validar que sea mayor de edad en backend y frontend
    var password = this.password.value.trim(),
        email    = this.email.value.trim();

    if (this.picture.value.trim()==='') {
      popup(' ¿ Y la foto ?','Debes subir una imagen de perfil');
      return false;
    };

    if (this.name.value.trim()==='') {
      popup('Hey! falta tu nombre','Debes ingresar tu nombre');
      return false;
    }

    if (this.lastname.value.trim()==='') {
      popup('Hey! falta tus apellidos','Debes ingresar tus apellidos');
      return false;
    }

    if ( this.email.value.trim()==='' || !validateEmail(this.email.value)) {
      popup('Hey! falta tu email','El email no es válido');
      return false;
    }

    if (this.birth.value.trim()==='') {
      popup('Hey! falta tu edad','Debes ingresar tu edad');
      return false;
    }

    if (password.length<3) {
      popup('','Tu contraseña debe tener por lo menos 3 carácteres');
      return false;
    }

    if ( password==='' || password !== this.password2.value ) {
      popup('Ops!','La constraseña no coincide');
      return false;
    }

    var formData = new FormData(this),
        formLogin= {password:password,email:email};

    setTimeout(function(){
      formData.append('latitude',$scope.point.latitude);
      formData.append('longitude',$scope.point.longitude);
      $.ajax({
        url: 'http://tianguisapp.herokuapp.com/signup',
        type: 'POST',
        data:  formData,
        contentType: false,
        cache: true,
        processData:false,
        xhrFields: {
          withCredentials: true
        },
        crossDomain: true,
        dataType: 'json',
        mimeType:'multipart/form-data',
        success: function (data) {
          console.log(data);
          if (data.error) {
            // Muestra el el error correspondiente
            showErrors(data.error.errors);
          }else{
            User.login(formLogin,$scope.point, function (err) {
              if (err) {
                popup(err);
              }else{
                $rootScope.$broadcast('categories', true);
                Chat.getChats(function (chats, chatsUsers) {
                  $scope.$broadcast('chat-list', chatsUsers);
                });
                console.log("test",User.getPendingUrl());
                if (User.getPendingUrl()) {
                  // Mandar a URL pendiente si existe
                  location = '#'+User.getPendingUrl();
                }else{
                  // mandar a home si no hay url pendiente
                  location = '#/products';
                }
              }
            });
          }

        },
        error: function (err) {
          console.log('error',err);
          popup('ERROR','No hay conexión a internet');
        },
        beforeSend: function(data){
          console.log(data);
          $scope.showLoad();
        },
        complete: function(data){
          console.log(data);
          $scope.hideLoad();
        }
      });
    }, 3000);

    e.preventDefault(); //Prevent Default action.
  });

  function popup (title,text,callback) {
    var alertPopup = $ionicPopup.alert({
      title: title,
      template: text
    });
    alertPopup.then(function (res) {
      if (callback) {
        callback();
      }
    });
  }

  function validateEmail(email) {
    var re = /^(([^<>()[\]\\.,;:\s@\']+(\.[^<>()[\]\\.,;:\s@\']+)*)|(\'.+\'))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
    return re.test(email);
  }

  function showErrors (errors) {
    console.log("errors",errors);
    if (errors.path === 'picture') {
      popup('ERROR','Imagen no válida');
    }else if( errors.path === 'name'){
      popup('ERROR','Nombre no válido');
    }else if( errors.path === 'lastname'){
      popup('ERROR','Aepllido no válido');
    }else if( errors.email){
      console.log("errors",errors);
      if (errors.email.name==='duplicateValue') {
        popup('ERROR','Este Email ya está registrado, intenta con otro');
      }else{
        popup('ERROR','Email no válido');
      }
    }else if( errors.path === 'birth' ){
      popup('ERROR','Edad no válida');
    }else if( errors.path === 'password'){
      popup('ERROR','Contraseña no válida');
    }else{
      popup('ERROR','');
    }
  }

})

.controller('LoginCtrl', function ($scope, $ionicPopup,$location, User, Chat, $rootScope, Geo, $ionicLoading) {
  var email, pass;

  // Default Position
  $scope.point = { latitude: 20.653467, longitude: -105.225255 };

  $scope.showLoad = function() {
    $ionicLoading.show({
      template: 'Un momento ya casi...'
    });
  };
  $scope.hideLoad = function(){
    $ionicLoading.hide();
  };

  $('#multiform').submit(function (e){
    $scope.showLoad();
    var login = {email:this.email.value,password:this.password.value}

    setTimeout(function(){
      User.login(login,$scope.point,function (err) {
        Chat.getChats(function (chats, chatsUsers) {
          console.log(chatsUsers);
          $scope.$broadcast('chat-list', chatsUsers);
          console.log("1");
        });
        $scope.hideLoad();
        if (err) {
          popup(err);
        }else{
          $rootScope.$broadcast('categories', true);
          if (User.getPendingUrl()) {
            // Mandar a URL pendiente si existe
            location = '#'+User.getPendingUrl();
          }else{
            // mandar a home si no hay url pendiente
            location = '#/';
          }
        }
      });
    }, 3000);

    e.preventDefault(); //Prevent Default action.
  });

  function popup (title,text,callback) {
    var alertPopup = $ionicPopup.alert({
      title: title,
      template: text
    });
    alertPopup.then(function (res) {
      if (callback) {
        callback();
      }
    });
  }

})

.controller('LoginIntroCtrl', function ($scope, $ionicPopup, User, Geo, $rootScope, Chat, $ionicLoading) {

  $scope.showLoad = function() {
    $ionicLoading.show({
      template: 'Un momento ya casi...'
    });
  };
  $scope.hideLoad = function(){
    $ionicLoading.hide();
  };

  $scope.errorHandler = function (err) {
    $scope.hideLoad();
    var alertPopup = $ionicPopup.alert({
      title: "Error",
      template: err
    });
  }

  $scope.loginSuccess = function () {
    $scope.hideLoad();
    console.log("procesa el usuario ya logueado");
    $rootScope.$broadcast('categories', true);
    Chat.getChats(function (chats, chatsUsers) {
      $scope.$broadcast('chat-list', chatsUsers);
    });
    if (User.getPendingUrl()) {
      // Mandar a URL pendiente si existe
      if (User.getPendingUrl()) {
        location = '#'+User.getPendingUrl();
      }else{
        location = '#/products';
      }
    }else{
      // mandar a home si no hay url pendiente
      location = '#/';
    }
  }

  $scope.facebookAccess = function (token) {
    $scope.showLoad();
    Geo.point(function (point) {
      console.log("point",point);
      $scope.point = point;
      var formLogin =  { password:token, email:"facebook", facebook:true };
      var formData =  new FormData();
      console.log("intenta loguearte",formLogin);
      User.login(formLogin,$scope.point,function (err) {
        if (err) {
          console.log("intea crear una cuenta");
          formData.append('email','facebook');
          formData.append('password',token);
          formData.append('latitude',$scope.point.latitude);
          formData.append('longitude',$scope.point.longitude);
          console.log("formData",formData);
          console.log("token",token,$scope.point);
          $.ajax({
            url: 'http://tianguisapp.herokuapp.com/signup-facebook',
            type: 'POST',
            data:  formData,
            contentType: false,
            cache: true,
            processData:false,
            xhrFields: {
              withCredentials: true
            },
            crossDomain: true,
            dataType: 'json',
            mimeType:'multipart/form-data',
            success: function (data) {
              console.log("cuenta creada, intenta loguearte",data);
              User.login(formLogin,$scope.point,function (err) {
                console.log("No se puede loguear usuario",err);
                if (err) {
                  $scope.errorHandler();
                }else{
                  $scope.loginSuccess();
                }
              });
            },
            error: function (err) {
              $scope.errorHandler(err);
            }
          });
        }else{
          $scope.loginSuccess();
        }
      });
    })
  };

  $scope.facebookLogin = function() {
    facebookConnectPlugin.login( ["email","public_profile"],
      function (response) {
        $scope.facebookAccess(response.authResponse.accessToken);
      },
      function (response) { errorHandler(response); }
    );
  }
})

.controller('MyProductsCtrl', function ($scope, $http, $ionicPopup, $location, User) {

  if (!User.isSaved()) {
    User.setPendingUrl($location.path());
    $location.path('/login-intro');
  }

  // Listado de productos
  $scope.products = [];

  // Tomar el ancho de la pantalla y dividirlo en 2 secciones
  var w = window,
  d = document,
  e = d.documentElement,
  g = d.getElementsByTagName('body')[0],
  x = w.innerWidth || w.screen.availWidth || e.clientWidth || g.clientWidth,
  elementWidth = (x / 2)-1;

  // Propiedades de las imágenes
  $scope.properties = {
    width: elementWidth
  };

  $.ajax({
    url: 'http://tianguisapp.herokuapp.com/products/owner/me',
    type: 'GET',
    contentType: false,
    cache: true,
    processData:false,
    async: false,
    xhrFields: {
      withCredentials: true
    },
    crossDomain: true,
    success: function (data) {
      $scope.products = data.products;
    },
    error: function (jqXHR, textStatus, errorThrown) {
      console.log(jqXHR, textStatus, errorThrown);
    }
  });

  $scope.remove = function remove(key, id) {
    console.log(key,id);
    var confirmPopup = $ionicPopup.confirm({
      title: ' Eliminarás uno de tus productos!!',
      template: '¿Estás seguro?'
    });
    confirmPopup.then(function(res) {
      if(res) {
        $.ajax({
          url: 'http://tianguisapp.herokuapp.com/product/'+id,
          type: 'DELETE',
          contentType: false,
          cache: true,
          processData:false,
          async: false,
          xhrFields: {
            withCredentials: true
          },
          crossDomain: true,
          success: function (data) {
            //TODO : estamos suponiendo que el key no se repite porque se retorna productos sin paginado
            if (data.error) {
              showError();
            }else{
              $scope.products.splice(key, 1);
              $scope.$apply();
            }
          },
          error: function (err) {
            console.log(err);
            showError();
          }
        });
      }
    });
  };

  $scope.openNewProduct = function () {
    $location.path('/new_product');
  }

  function showError () {
    $ionicPopup.alert({
      title: "Wops!!",
      template: "Algo anda mal intenta nuevamente"
    })
  }

})

.controller('ChatCtrl', function ($scope, $ionicScrollDelegate, $stateParams, User, $location, Chat, socket) {

  // Si el usuario no está loeguado no hagas nada
  if (!User.isSaved()) {
    $location.path('/products');
  };

  // Definiendo variables
  var user = User.getInfo()
    , tmpMessage
    , totalMsg = 0
    , classMsg = "right"
    , user     = User.getInfo();
  // Define el contenido de el chat
  $scope.html  = '';
  // Define el id del vendedor
  $scope.sellerId = $stateParams.id;
  // Manda el scroll al final de la página
  $scope.init = function () {
    $ionicScrollDelegate.scrollBottom();
  }

  // Función que agrega un mensaje al contenido
  $scope.showMessage = function (img, date, msg, side) {
    totalMsg ++;
    $scope.html += '<li class="item item-positive message '+side+'">  \
              <img src="'+img+'"  class="profile"> \
              <div class="content"> \
                <div class="time">'+date+'</div> \
                <p>'+msg+'</p> \
              </div> \
            </li>';
    $ionicScrollDelegate.scrollBottom();
  };

  // Obten el historial si encuentras algo
  $.ajax({
    url: 'http://tianguisapp.herokuapp.com/chat/'+$stateParams.id,
    type: 'GET',
    contentType: false,
    cache: true,
    processData:false,
    async: false,
    xhrFields: {
      withCredentials: true
    },
    crossDomain: true,
    success: function (data) {
      console.log(data);
      var messages, side, img, date, msg, d;
      if (data.chat) {
        if (data.chat.messages) {
          $scope.sellerName = data.toUser.name;
          messages = data.chat.messages
          if (messages.length > 0) {
            for (var i = 0; i < messages.length; i++) {
              d = new Date(messages[i].date);
              d = d.getFullYear()+'/'+d.getMonth()+'/'+d.getDate();

              if ( messages[i].owner === user._id ) {
                side = 'left';
                img  = user.picture.path_t;
              }else{
                side = 'right';
                img  = data.toUser.img;
              }
              $scope.showMessage(img, d, messages[i].msg, side);
            };
          }
        }else{
          console.log('No hay una variable de mensajes');
        }
      }else{
        console.log('No hay una variable de chat');
      }
    },
    error: function (jqXHR) {
      console.log(jqXHR);
    }
  });


  // Cuando se envia un mensaje a determinado usuario hacer...
  $scope.sendMsg = function (msg) {
    if (!msg) {
      msg    = $('#msg').val();
    }

    // No continues si el mensaje o el usuario están en blanco
    if (msg.trim()==='') { return; }

    // Crea una instancia de la fecha y se convierte a String
    var d = new Date();
    var date = d.toLocaleDateString();

    // Envia el mensaje por un socket
    socket.emit('message', {toUser:{_id:$scope.sellerId },fromUser:{_id:user._id,msg:msg,date:date}});

    // Agrega el texto del mismo usuario al historial
    $scope.showMessage(user.picture.path_t,date,msg,'left');

    // Limpiar caja de texto
    $('#msg').val('');
  };
  // Si hay algun mensaje pendiente por mandar enviarlo
  tmpMessage = Chat.getTmpMessage();
  console.log(tmpMessage);
  if (tmpMessage !== '') {
    $scope.sendMsg(tmpMessage);
  }

  // cuando se reciva un mensaje hacer...
  socket.on('message',function (data) {
    console.log(data);
    $scope.showMessage(data.img, data.date, data.msg,'right');
  });

})

.controller('ProductCtrl', function ($scope, $stateParams, $location, $ionicModal, User, Chat) {

  $scope.product = {};
  $scope.owner   = {};

  // Define la cantidad de estrellas y rellena una por default
  $scope.start = {
    stack: [0,1,2,3,4],
    full: 1,
  };

  $scope.updateStarts = function (n) {
    $scope.start.full = n;
  };
  $scope.startsAccept = function () {
    // TODO: Actualmente es sólo se puede calificar una vez pero no se ha validado por el cliente
    var formData = new FormData(this);
    formData.append('score',$scope.start.full);
    formData.append('seller_id',$scope.product.owner);
    console.log($scope.start.full,$scope.product.owner);
    $.ajax({
      url: 'http://tianguisapp.herokuapp.com/user',
      type: 'PUT',
      data:  formData,
      contentType: false,
      cache: true,
      processData:false,
      xhrFields: {
        withCredentials: true
      },
      crossDomain: true,
      dataType: 'json',
      success: function (data) {
        console.log(data);
        $scope.closeModal();
      },
      error: function (data) {
        console.log(data.responseText);
        $scope.closeModal();
      }
    });
  }


  $.ajax({
    url: 'http://tianguisapp.herokuapp.com/product/'+$stateParams.id,
    type: 'GET',
    contentType: false,
    cache: true,
    processData:false,
    async: false,
    xhrFields: {
      withCredentials: true
    },
    crossDomain: true,
    success: function (data) {
      console.log(data);
      if (!data.error) {
        $scope.product = data.product;
      }else{
        if (data.error.errors.system) {
          console.log(data.error.errors.system.name);
        }
      }
    },
    error: function (error) {
      console.log(error);
    }
  });

  $.ajax({
    url: 'http://tianguisapp.herokuapp.com/user/'+$scope.product.owner,
    type: 'GET',
    contentType: false,
    cache: true,
    processData:false,
    async: false,
    xhrFields: {
      withCredentials: true
    },
    crossDomain: true,
    success: function (data) {
      if (!data.error) {
        data.user.score_total = Math.ceil(data.user.score_total);
        if (data.user.picture.path_t == "" ) {
          data.user.picture.path_t = '../images/default-user.png';
        }

        $scope.owner = data.user;
      }else{
        if (data.error.errors.system) {
          console.log(data.error.errors.system.name);
        }
      }
    },
    error: function (error) {
      console.log(error);
    }
  });


  $scope.sendMessage = function (msg) {
    if (User.isSaved()) {
      Chat.setTmpMessage(msg);
      $location.path('/chat/'+$scope.owner._id);
    }else{
      User.setPendingUrl($location.path());
      $location.path('/login-intro');
    }
  };

  $scope.submit = function () {
    $scope.sendMessage($("#msg").val());
    $("#msg").val('');
  }


  $ionicModal.fromTemplateUrl('modal-starts.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modal = modal;
  });
  $scope.openModal = function() {
    $scope.modal.show();
  };
  $scope.closeModal = function() {
    $scope.modal.hide();
  };
  // Execute action on hide modal
  $scope.$on('modal.hidden', function() {
    // Execute action
  });
  // Execute action on remove modal
  $scope.$on('modal.removed', function() {
    // Execute action
  });

})

.controller('SinguplocationCtrl', function ($scope,$http, formService) {

  // ESTE CONTROLADOR CON SU RESPECTIVA VISTA NO ESATARÁ ACTIVIDADO DEBIDO A QUE ANDROID SERÁ EL TARGET
  // PODRÁ SER UTILIZADO CUANDO SE REALICE UN VERSIÓN WEB O PARA IOS

  function callUpdateStates (country_id) {
    $http({method: 'GET', url: 'http://api.geonames.org/childrenJSON?geonameId='+country_id+'&username=isidro'}).
      success(function (data, status, headers, config) {
        $scope.states = data.geonames;
      }).
      error(function (data, status, headers, config) {
        console.log('error');
      });
  }

  $scope.mexicoId = 3996063;
  $scope.point = { latitude: 20.653467, longitude: -105.225255 };
  callUpdateStates($scope.mexicoId);
  $http({method: 'GET', url: 'http://api.geonames.org/countryInfoJSON?username=isidro'}).
    success(function (data, status, headers, config) {
      $scope.countries = data.geonames;
    }).
    error(function (data, status, headers, config) {
      console.log('error');
    });

  $scope.updateStates = function () {
    callUpdateStates(this.country_id);
  };

  $scope.updateRegion = function () {
    $http({method: 'GET', url: 'http://api.geonames.org/childrenJSON?geonameId='+this.state_id+'&username=isidro'}).
      success(function (data, status, headers, config) {
        $scope.regions = data.geonames;
      }).
      error(function (data, status, headers, config) {
        console.log('error');
      });
  };

  $scope.setPoint = function () {
    var key;
    console.log($scope.regions);
    for (key in $scope.regions) {
      if ($scope.regions[key].geonameId===this.region_id) {
        $scope.point = { latitude: $scope.regions[key].lat, longitude: $scope.regions[key].lng };
        $scope.myStyle = 'display:block';
      }
    }
  };

  $scope.$watch('some',function () {
    $scope.states = [];
    $scope.regions = [];
    $scope.myStyle = 'display:none';
  });



  $scope.submit = function () {
    var formData = formService.get();
    formData.append('latitude',$scope.point.latitude);
    formData.append('longitude',$scope.point.longitude);
    console.log(formData);
    $.ajax({
      url: 'http://tianguisapp.herokuapp.com/test',
      type: 'POST',
      data:  formData,
      mimeType:'multipart/form-data',
      contentType: false,
      cache: false,
      processData:false,
      success: function (data) {
        console.log(data);
      },
      error: function (jqXHR, textStatus, errorThrown) {
        alert(errorThrown);
      }
    });
  };
});

// Activida el menú de la derecha
function ContentController($scope, $ionicSideMenuDelegate) {
  $scope.toggleLeft = function () {
    $ionicSideMenuDelegate.toggleLeft();
  };
}